## bowtie 1.2.2+dfsg

=== Makefile ===
#
# Makefile for bowtie, bowtie-build, bowtie-inspect
#

prefix = /usr/local
bindir = $(prefix)/bin

SEQAN_DIR = ./SeqAn-1.1
# treat SeqAn as a sysdir to suppress warnings
SEQAN_INC = -isystem $(SEQAN_DIR)
INC = $(if $(RELEASE_BUILD),-I$(CURDIR)/.include) $(SEQAN_INC) -I third_party
CPP = g++
CXX = $(CPP)
CC = gcc
LIBS = $(LDFLAGS) $(if $(RELEASE_BUILD),-L$(CURDIR)/.lib) -lz
HEADERS = $(wildcard *.h)
BOWTIE_MM = 1
BOWTIE_SHARED_MEM = 1
EXTRA_FLAGS =
EXTRA_CFLAGS =
EXTRA_CXXFLAGS =
CFLAGS += $(EXTRA_CFLAGS)
CXXFLAGS += $(EXTRA_CXXFLAGS)
WARNING_FLAGS = -Wall -Wno-unused-parameter -Wno-reorder \
				-Wno-unused-local-typedefs

RELEASE_DEPENDENCIES = $(if $(RELEASE_BUILD),static-libs)

# Detect Cygwin or MinGW
WINDOWS =
CYGWIN =
MINGW =
ifneq (,$(findstring CYGWIN,$(shell uname)))
    WINDOWS = 1
    CYGWIN = 1
    # POSIX memory-mapped files not currently supported on Windows
    BOWTIE_MM = 0
    BOWTIE_SHARED_MEM = 0
else
    ifneq (,$(findstring MINGW,$(shell uname)))
	WINDOWS = 1
	MINGW = 1
	# POSIX memory-mapped files not currently supported on Windows
	BOWTIE_MM = 0
	BOWTIE_SHARED_MEM = 0
    endif
endif

MACOS =
ifneq (,$(findstring Darwin,$(shell uname)))
    MACOS = 1
	ifneq (,$(findstring 13,$(shell uname -r)))
		CPP = clang++
		CC = clang
		override EXTRA_FLAGS += -stdlib=libstdc++
	endif
	ifeq (1, $(RELEASE_BUILD))
		EXTRA_FLAGS += -mmacosx-version-min=10.9
	endif
endif

LINUX =
ifneq (,$(findstring Linux,$(shell uname)))
    LINUX = 1
    override EXTRA_FLAGS += -Wl,--hash-style=both
endif

MM_DEF = 
ifeq (1,$(BOWTIE_MM))
    MM_DEF = -DBOWTIE_MM
endif
SHMEM_DEF = 
ifeq (1,$(BOWTIE_SHARED_MEM))
    SHMEM_DEF = -DBOWTIE_SHARED_MEM
endif
PTHREAD_PKG =
PTHREAD_LIB =
PTHREAD_DEF =

#if we're not using TBB, then we can't use queuing locks
ifeq (1,$(NO_TBB))
	NO_QUEUELOCK=1
endif

ifeq (1,$(MINGW))
	PTHREAD_LIB = 
	override EXTRA_FLAGS += -static-libgcc -static-libstdc++
else
    PTHREAD_LIB = -lpthread
endif

ifeq (1,$(NO_SPINLOCK))
	override EXTRA_FLAGS += -DNO_SPINLOCK
endif

ifneq (1,$(NO_TBB))
	LIBS += $(PTHREAD_LIB) -ltbb
	LIBS += -ltbbmalloc$(if $(RELEASE_BUILD),,_proxy)
	override EXTRA_FLAGS += -DWITH_TBB
else
	LIBS += $(PTHREAD_LIB)
endif

POPCNT_CAPABILITY ?= 1
ifeq (1, $(POPCNT_CAPABILITY))
    override EXTRA_FLAGS += -DPOPCNT_CAPABILITY
    INC += -I third_party
endif

PREFETCH_LOCALITY = 2
PREF_DEF = -DPREFETCH_LOCALITY=$(PREFETCH_LOCALITY)


SEARCH_LIBS = 
BUILD_LIBS =
INSPECT_LIBS = 

ifeq (1,$(MINGW))
    BUILD_LIBS = 
    INSPECT_LIBS = 
endif

ifeq (1,$(WITH_THREAD_PROFILING))
	override EXTRA_FLAGS += -DPER_THREAD_TIMING=1
endif

ifeq (1,$(WITH_AFFINITY))
	override EXTRA_FLAGS += -DWITH_AFFINITY=1
endif

ifeq (1,$(WITH_QUEUELOCK))
	override EXTRA_FLAGS += -DWITH_QUEUELOCK=1
endif

ifeq (1,$(WITH_FINE_TIMER))
	override EXTRA_FLAGS += -DUSE_FINE_TIMER=1
endif

OTHER_CPPS = ccnt_lut.cpp ref_read.cpp alphabet.cpp shmem.cpp \
             edit.cpp ebwt.cpp

ifeq (1,$(WITH_COHORTLOCK))
	override EXTRA_FLAGS += -DWITH_COHORTLOCK=1
	OTHER_CPPS += cohort.cpp cpu_numa_info.cpp
endif

ifeq (1,$(NO_TBB))
	OTHER_CPPS += tinythread.cpp
endif

SEARCH_CPPS = qual.cpp pat.cpp ebwt_search_util.cpp ref_aligner.cpp \
              log.cpp hit_set.cpp sam.cpp \
              color.cpp color_dec.cpp hit.cpp
SEARCH_CPPS_MAIN = $(SEARCH_CPPS) bowtie_main.cpp

BUILD_CPPS =
BUILD_CPPS_MAIN = $(BUILD_CPPS) bowtie_build_main.cpp

SEARCH_FRAGMENTS = $(wildcard search_*_phase*.c)
VERSION = $(shell cat VERSION)

BITS=32
ifeq (x86_64,$(shell uname -m))
	BITS=64
endif
# msys will always be 32 bit so look at the cpu arch instead.
ifneq (,$(findstring AMD64,$(PROCESSOR_ARCHITEW6432)))
	ifeq (1,$(MINGW))
		BITS=64
	endif
endif

ifeq (1,$(LINUX))
    ifeq (x86_64, $(shell uname -p))
        BITS=64
    endif
endif

ifeq (32,$(BITS))
    $(error bowtie2 compilation requires a 64-bit platform )
endif

DEBUG_FLAGS = -O0 -g3 -m64
RELEASE_FLAGS = -O3 -m64
NOASSERT_FLAGS = -DNDEBUG
FILE_FLAGS = -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE

BIN_LIST = bowtie-build-s \
           bowtie-build-l \
           bowtie-align-s \
           bowtie-align-l \
           bowtie-inspect-s \
           bowtie-inspect-l
BIN_LIST_AUX = bowtie-build-s-debug \
               bowtie-build-l-debug \
               bowtie-align-s-debug \
               bowtie-align-l-debug \
               bowtie-inspect-s-debug \
               bowtie-inspect-l-debug

GENERAL_LIST = $(wildcard scripts/*.sh) \
               $(wildcard scripts/*.pl) \
               $(wildcard scripts/*.py) \
               $(wildcard indexes/e_coli*) \
               $(wildcard genomes/NC_008253.fna) \
               $(wildcard reads/e_coli_1000.*) \
               $(wildcard reads/e_coli_1000_*) \
               SeqAn-1.1 \
               bowtie \
               bowtie-build \
               bowtie-inspect \
               doc/manual.html \
               doc/README \
               doc/style.css \
               reads/e_coli_10000snp.fa \
               reads/e_coli_10000snp.fq \
               $(PTHREAD_PKG) \
               AUTHORS \
               LICENSE \
               NEWS \
               MANUAL \
               MANUAL.markdown \
               TUTORIAL \
               VERSION

SRC_PKG_LIST = $(wildcard *.h) \
               $(wildcard *.hh) \
               $(wildcard *.c) \
               $(wildcard *.cpp) \
               $(wildcard third_party/*.h) \
               $(wildcard third_party/*.hh) \
               $(wildcard third_party/*.c) \
               $(wildcard third_party/*.cpp) \
               doc/strip_markdown.pl \
               Makefile \
               $(GENERAL_LIST)

BIN_PKG_LIST = $(GENERAL_LIST)

all: $(BIN_LIST)

allall: $(BIN_LIST) $(BIN_LIST_AUX)

DEFS=-fno-strict-aliasing \
     -DBOWTIE_VERSION="\"`cat VERSION`\"" \
     -DBUILD_HOST="\"`hostname`\"" \
     -DBUILD_TIME="\"`date`\"" \
     -DCOMPILER_VERSION="\"`$(CXX) -v 2>&1 | tail -1`\"" \
     $(FILE_FLAGS) \
     $(PTHREAD_DEF) \
     $(PREF_DEF) \
     $(MM_DEF) \
     $(SHMEM_DEF)

ALL_FLAGS = $(EXTRA_FLAGS) $(CFLAGS) $(CXXFLAGS)
DEBUG_DEFS = -DCOMPILER_OPTIONS="\"$(DEBUG_FLAGS) $(ALL_FLAGS)\""
RELEASE_DEFS = -DCOMPILER_OPTIONS="\"$(RELEASE_FLAGS) $(ALL_FLAGS)\""

#
# bowtie-build targets
#

bowtie-build-s: ebwt_build.cpp $(OTHER_CPPS) $(HEADERS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(ALL_FLAGS)  \
		$(DEFS) $(NOASSERT_FLAGS) $(WARNING_FLAGS) \
		$(INC) \
		-o $@ $< \
		$(OTHER_CPPS) $(BUILD_CPPS_MAIN) \
		$(LIBS) $(BUILD_LIBS)

bowtie-build-l: ebwt_build.cpp $(OTHER_CPPS) $(HEADERS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(ALL_FLAGS)  \
		$(DEFS) -DBOWTIE_64BIT_INDEX $(NOASSERT_FLAGS) $(WARNING_FLAGS) \
		$(INC) \
		-o $@ $< \
		$(OTHER_CPPS) $(BUILD_CPPS_MAIN) \
		$(LIBS) $(BUILD_LIBS)

bowtie-build_prof: ebwt_build.cpp $(OTHER_CPPS) $(HEADERS)
	$(CXX) $(RELEASE_FLAGS) -pg -p -g3 $(RELEASE_DEFS) $(ALL_FLAGS) \
		$(DEFS) $(NOASSERT_FLAGS) $(WARNING_FLAGS) \
		$(INC) \
		-o $@ $< \
		$(OTHER_CPPS) $(BUILD_CPPS_MAIN) \
		$(LIBS) $(BUILD_LIBS)

bowtie-build-s-debug: ebwt_build.cpp $(OTHER_CPPS) $(HEADERS)
	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(ALL_FLAGS) \
		$(DEFS) $(WARNING_FLAGS) \
		$(INC) \
		-o $@ $< \
		$(OTHER_CPPS) $(BUILD_CPPS_MAIN) \
		$(LIBS) $(BUILD_LIBS)

bowtie-build-l-debug: ebwt_build.cpp $(OTHER_CPPS) $(HEADERS)
	$(CXX) $(DEBUG_FLAGS) $(DEBUG_DEFS) $(ALL_FLAGS) \
		$(DEFS) -DBOWTIE_64BIT_INDEX $(WARNING_FLAGS) \
		$(INC) \
		-o $@ $< \
		$(OTHER_CPPS) $(BUILD_CPPS_MAIN) \
		$(LIBS) $(BUILD_LIBS)

#
# bowtie targets
#

bowtie-align-s: ebwt_search.cpp $(SEARCH_CPPS) $(OTHER_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(ALL_FLAGS) \
		$(DEFS) $(NOASSERT_FLAGS) $(WARNING_FLAGS) \
		$(INC) \
		-o $@ $< \
		$(OTHER_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LIBS) $(SEARCH_LIBS)

bowtie-align-l: ebwt_search.cpp $(SEARCH_CPPS) $(OTHER_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(RELEASE_FLAGS) $(RELEASE_DEFS) $(ALL_FLAGS) \
		$(DEFS) $(NOASSERT_FLAGS) -DBOWTIE_64BIT_INDEX $(WARNING_FLAGS) \
		$(INC) \
		-o $@ $< \
		$(OTHER_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LIBS) $(SEARCH_LIBS)

bowtie_prof: ebwt_search.cpp $(SEARCH_CPPS) $(OTHER_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(RELEASE_FLAGS) \
		$(RELEASE_DEFS) -pg -p -g3 $(ALL_FLAGS) \
		$(DEFS) $(NOASSERT_FLAGS) $(WARNING_FLAGS) \
		$(INC) \
		-o $@ $< \
		$(OTHER_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LIBS) $(SEARCH_LIBS)

bowtie-align-s-debug: ebwt_search.cpp $(SEARCH_CPPS) $(OTHER_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(ALL_FLAGS) \
		$(DEFS) $(WARNING_FLAGS) \
		$(INC) \
		-o $@ $< \
		$(OTHER_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LIBS) $(SEARCH_LIBS)

bowtie-align-l-debug: ebwt_search.cpp $(SEARCH_CPPS) $(OTHER_CPPS) $(HEADERS) $(SEARCH_FRAGMENTS)
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(ALL_FLAGS) \
		$(DEFS) -DBOWTIE_64BIT_INDEX $(WARNING_FLAGS) \
		$(INC) \
		-o $@ $< \
		$(OTHER_CPPS) $(SEARCH_CPPS_MAIN) \
		$(LIBS) $(SEARCH_LIBS)

#
# bowtie-inspect targets
#

bowtie-inspect-s: bowtie_inspect.cpp $(HEADERS) $(OTHER_CPPS)
	$(CXX) $(RELEASE_FLAGS) \
		$(RELEASE_DEFS) $(ALL_FLAGS) \
		$(DEFS) $(WARNING_FLAGS) \
		$(INC) -I . \
		-o $@ $< \
		$(OTHER_CPPS) \
		$(LIBS)

bowtie-inspect-l: bowtie_inspect.cpp $(HEADERS) $(OTHER_CPPS)
	$(CXX) $(RELEASE_FLAGS) \
		$(RELEASE_DEFS) $(ALL_FLAGS) \
		$(DEFS) -DBOWTIE_64BIT_INDEX $(WARNING_FLAGS) \
		$(INC) -I . \
		-o $@ $< \
		$(OTHER_CPPS) \
		$(LIBS)

bowtie-inspect-s-debug: bowtie_inspect.cpp $(HEADERS) $(OTHER_CPPS) 
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(ALL_FLAGS) \
		$(DEFS) $(WARNING_FLAGS) \
		$(INC) -I . \
		-o $@ $< \
		$(OTHER_CPPS) \
		$(LIBS)

bowtie-inspect-l-debug: bowtie_inspect.cpp $(HEADERS) $(OTHER_CPPS) 
	$(CXX) $(DEBUG_FLAGS) \
		$(DEBUG_DEFS) $(ALL_FLAGS) \
		$(DEFS) -DBOWTIE_64BIT_INDEX $(WARNING_FLAGS) \
		$(INC) -I . \
		-o $@ $< \
		$(OTHER_CPPS) \
		$(LIBS)

bowtie-src.zip: $(SRC_PKG_LIST)
	chmod a+x scripts/*.sh scripts/*.pl
	mkdir .src.tmp
	mkdir .src.tmp/bowtie-$(VERSION)
	zip -r tmp.zip $(SRC_PKG_LIST)
	mv tmp.zip .src.tmp/bowtie-$(VERSION)
	cd .src.tmp/bowtie-$(VERSION) ; unzip tmp.zip ; rm -f tmp.zip
	cd .src.tmp ; zip -r $@ bowtie-$(VERSION)
	cp .src.tmp/$@ .
	rm -rf .src.tmp

bowtie-bin.zip: $(RELEASE_DEPENDENCIES) $(BIN_PKG_LIST) $(BIN_LIST) $(BIN_LIST_AUX) 
	$(eval PKG_DIR=bowtie-$(VERSION)-$(if $(MACOS),macos,$(if $(MINGW),mingw,linux))-x86_64)
	chmod a+x scripts/*.sh scripts/*.pl
	rm -rf .bin.tmp
	mkdir .bin.tmp
	mkdir -p .bin.tmp/$(PKG_DIR)
	if [ -f bowtie-align-s.exe ] ; then \
		zip tmp.zip $(BIN_PKG_LIST) $(addsuffix .exe,$(BIN_LIST) $(BIN_LIST_AUX)) ; \
	else \
		zip tmp.zip $(BIN_PKG_LIST) $(BIN_LIST) $(BIN_LIST_AUX) ; \
	fi
	mv tmp.zip .bin.tmp/$(PKG_DIR)
	cd .bin.tmp/$(PKG_DIR) ; unzip tmp.zip ; rm -f tmp.zip
	cd .bin.tmp ; zip -r $(PKG_DIR).zip $(PKG_DIR)
	cp .bin.tmp/$(PKG_DIR).zip .
	rm -rf .bin.tmp

.PHONY: doc
doc: doc/manual.html MANUAL

doc/manual.html: MANUAL.markdown
	echo "<h1>Table of Contents</h1>" > .tmp.head
	pandoc -T "Bowtie Manual" -B .tmp.head \
	       --css style.css -o $@ \
	       --from markdown --to HTML \
	       --table-of-contents $^

MANUAL: MANUAL.markdown
	perl doc/strip_markdown.pl < $^ > $@

.PHONY: install
install: all
	mkdir -p $(DESTDIR)$(bindir)
	for file in $(BIN_LIST) bowtie-inspect bowtie-build bowtie ; do \
		cp -f $$file $(DESTDIR)$(bindir) ; \
	done

.PHONY: simple-test
simple-test: allall perl-deps
	eval `perl -I $(CURDIR)/.perllib.tmp/lib/perl5 -Mlocal::lib=$(CURDIR)/.perllib.tmp` ; \
	./scripts/test/simple_tests.pl --bowtie=./bowtie --bowtie-build=./bowtie-build

.PHONY: random-test
random-test: all perl-deps
	eval `perl -I $(CURDIR)/.perllib.tmp/lib/perl5 -Mlocal::lib=$(CURDIR)/.perllib.tmp` ; \
	./scripts/test/random_bowtie_tests.sh

.PHONY: perl-deps
perl-deps:
	if [ ! -e .perllib.tmp ]; then \
		DL=$$([ `which wget` ] && echo wget -O- || echo curl -L) ; \
		mkdir .perllib.tmp ; \
		$$DL http://cpanmin.us | perl - -l $(CURDIR)/.perllib.tmp App::cpanminus local::lib ; \

=== debian/changelog ===
bowtie (1.2.2+dfsg-2) unstable; urgency=medium

  * Update d/tests/run-unit-test
    -  export BOWTIE_INDEXES, Closes: #888844
    -  enable test for example9
  * Bump Standards-Version to 4.1.3 (No changes needed),
    set debhelper & d/compat to version 11

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Wed, 31 Jan 2018 14:04:41 +0100

bowtie (1.2.2+dfsg-1) unstable; urgency=medium

  * New upstream version 1.2.2~beta+dfsg
  * Refresh patches
  * New upstream version 1.2.2+dfsg
  * Refresh patches
  * Bump Standards-Version to 4.1.2
  * Update copyright, note license change to Artistic License 2.0

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Sat, 16 Dec 2017 19:17:18 +0100

bowtie (1.2.1.1+dfsg-1) unstable; urgency=medium

  [ Andreas Tille ]
  * New upstream version
  * Moved packaging from SVN to Git
  * debhelper 10
  * Simplified d/watch
  * Build-Depends: zlib1g-dev

  [ Steffen Moeller ]
  * debian/upstream/metadata:
    - Completed references to registries
    - yamllint cleanliness

  [ Alexandre Mestiashvili ]
  * Update d/copyright:
    - use https for Format field
    - link to versioned license
    - add .cvsignore to Files-Excluded list
    - add myself to debian/* section
  * Add myself to uploaders, bump Standards-Version
  * Rearrange patch headers (cme fix dpkg), update spelling.patch
  * Re-introduce no_hash_style_both_for_mips.patch fixing build on mips64el
    Closes: #864448
  * Update d/rules:
    - drop get-orig-source target
    - hardcode binary package name instead of using dpkg-parsechangelog
  * Disable unit tests for example6 and example9 as the output is different
    compared to older bowtie versions
  * Override lintian's warnings for binaries used with wrapper scripts

 -- Alexandre Mestiashvili <alex@biotec.tu-dresden.de>  Thu, 19 Oct 2017 20:35:11 +0200

=== debian/control ===
Source: bowtie
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Steffen Moeller <moeller@debian.org>,
           Andreas Tille <tille@debian.org>,
           Ognyan Kulev <ogi@debian.org>,
           Stephan Struckmann <stephan.struckmann@gmail.com>,
           Alexandre Mestiashvili <alex@biotec.tu-dresden.de>
Section: science
Priority: optional
Build-Depends: debhelper (>= 11),
               help2man,
               libtbb-dev,
               python,
               seqan-dev (>= 1.4),
               zlib1g-dev
Standards-Version: 4.1.3
Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/bowtie.git
Vcs-Git: https://anonscm.debian.org/git/debian-med/bowtie.git
Homepage: http://bowtie-bio.sourceforge.net/

Package: bowtie
Architecture: alpha any-amd64 arm64 mips64el ppc64 ppc64el s390x sparc64
Depends: ${shlibs:Depends},
         ${misc:Depends},
         python
Suggests: bowtie-examples
Description: Ultrafast memory-efficient short read aligner
 This package addresses the problem to interpret the results from the
 latest (2010) DNA sequencing technologies. Those will yield fairly
 short stretches and those cannot be interpreted directly. It is the
 challenge for tools like Bowtie to give a chromosomal location to the
 short stretches of DNA sequenced per run.
 .
 Bowtie aligns short DNA sequences (reads) to the human genome at a rate
 of over 25 million 35-bp reads per hour. Bowtie indexes the genome with
 a Burrows-Wheeler index to keep its memory footprint small: typically
 about 2.2 GB for the human genome (2.9 GB for paired-end).

Package: bowtie-examples
Architecture: all
Depends: ${misc:Depends}
Recommends: bowtie
Enhances: bowtie
Description: Examples for bowtie, the ultrafast memory-efficient short read aligner
 This package addresses the problem to interpret the results from the
 latest (2010) DNA sequencing technologies. Those will yield fairly
 short stretches and those cannot be interpreted directly. It is the
 challenge for tools like Bowtie to give a chromosomal location to the
 short stretches of DNA sequenced per run.
 .
 Bowtie aligns short DNA sequences (reads) to the human genome at a rate
 of over 25 million 35-bp reads per hour. Bowtie indexes the genome with
 a Burrows-Wheeler index to keep its memory footprint small: typically
 about 2.2 GB for the human genome (2.9 GB for paired-end).
 .
 This package provides some example data to work with bowtie.

=== debian/tests/control ===
Tests: run-unit-test
Depends: @, bowtie-examples
Restrictions: allow-stderr

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
  https://github.com/BenLangmead/bowtie/releases .*/archive/v@ANY_VERSION@@ARCHIVE_EXT@

## bowtie 1.2.3%2Bdfsg

=== Makefile ===
--- 
+++ 
@@ -420,9 +420,10 @@
 
 doc/manual.html: MANUAL.markdown
 	echo "<h1>Table of Contents</h1>" > .tmp.head
-	pandoc -T "Bowtie Manual" -B .tmp.head \
+	pandoc -B .tmp.head \
 	       --css style.css -o $@ \
 	       --from markdown --to HTML \
+	       --metadata title:"Bowtie Manual" \
 	       --table-of-contents $^
 
 MANUAL: MANUAL.markdown
@@ -450,4 +451,3 @@
 	if [ ! -e .perllib.tmp ]; then \
 		DL=$$([ `which wget` ] && echo wget -O- || echo curl -L) ; \
 		mkdir .perllib.tmp ; \
-		$$DL http://cpanmin.us | perl - -l $(CURDIR)/.perllib.tmp App::cpanminus local::lib ; \

=== debian/control ===
--- 
+++ 
@@ -4,25 +4,29 @@
            Andreas Tille <tille@debian.org>,
            Ognyan Kulev <ogi@debian.org>,
            Stephan Struckmann <stephan.struckmann@gmail.com>,
-           Alexandre Mestiashvili <alex@biotec.tu-dresden.de>
+           Alexandre Mestiashvili <mestia@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper (>= 11),
+Build-Depends: debhelper-compat (= 12),
                help2man,
                libtbb-dev,
-               python,
-               seqan-dev (>= 1.4),
-               zlib1g-dev
-Standards-Version: 4.1.3
-Vcs-Browser: https://anonscm.debian.org/cgit/debian-med/bowtie.git
-Vcs-Git: https://anonscm.debian.org/git/debian-med/bowtie.git
+               python3,
+               seqan-dev,
+               zlib1g-dev,
+               libclone-perl,
+               libtest-deep-perl,
+               libsys-info-perl
+Standards-Version: 4.4.0
+Vcs-Browser: https://salsa.debian.org/med-team/bowtie
+Vcs-Git: https://salsa.debian.org/med-team/bowtie.git
 Homepage: http://bowtie-bio.sourceforge.net/
 
 Package: bowtie
-Architecture: alpha any-amd64 arm64 mips64el ppc64 ppc64el s390x sparc64
+Architecture: alpha any-amd64 arm64 mips64el ppc64 ppc64el s390x sparc64 riscv64
+Multi-Arch: foreign
 Depends: ${shlibs:Depends},
          ${misc:Depends},
-         python
+         python3
 Suggests: bowtie-examples
 Description: Ultrafast memory-efficient short read aligner
  This package addresses the problem to interpret the results from the

## bowtie 1.2.3+dfsg

=== debian/changelog ===
bowtie (1.2.3+dfsg-4build1) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Sun, 22 Mar 2020 16:35:15 +0100

bowtie (1.2.3+dfsg-4) unstable; urgency=medium

  * Team upload.
  * Switch to single threaded testing, add riscv64

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Sat, 11 Jan 2020 12:14:53 +0100

bowtie (1.2.3+dfsg-3) unstable; urgency=medium

  * Team upload.
  * autopkgtest: s/ADTTMP/AUTOPKGTEST_TMP/g
  * `make simple-test` in addition to our own tests
  * Remove obsolete fields Contact from debian/upstream/metadata.

 -- Michael R. Crusoe <michael.crusoe@gmail.com>  Wed, 08 Jan 2020 12:39:33 +0100

bowtie (1.2.3+dfsg-2) unstable; urgency=medium

  * Use python3 in (Build-)Depends in d/control
  * Use 2to3 to port scripts to python3, Closes: #936232

 -- Alexandre Mestiashvili <mestia@debian.org>  Thu, 05 Sep 2019 17:49:44 +0200

bowtie (1.2.3+dfsg-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Fix edam syntax input+output is singular

  [ Alexandre Mestiashvili ]
  * New upstream version 1.2.3+dfsg
  * Drop applied by upstream and refresh patches
  * Add strip_html5shiv.patch, removing condition loading html5shiv for old IEs
  * Update d/control, remove version from seqan-dev, bump Policy to 4.4.0
  * Switch to debhelper-compat, drop d/compat

 -- Alexandre Mestiashvili <mestia@debian.org>  Thu, 11 Jul 2019 16:09:02 +0200

bowtie (1.2.2+dfsg-4) unstable; urgency=medium

  [ Andreas Tille ]
  * spelling
  * Upload to unstable

  [ Dylan Aïssi ]
  * Update metadata: Add bio.tools ref

  [ Alexandre Mestiashvili ]
  * Add patch fixing FTBFS, thanks to ch4rr0 at github.com
    Closes: #906341
  * Check for DEB_BUILD_OPTIONS and nocheck

 -- Alexandre Mestiashvili <mestia@debian.org>  Wed, 05 Sep 2018 14:34:56 +0000

bowtie (1.2.2+dfsg-3) unstable; urgency=medium

  * Fix watch file to not detect beta versions
  * Point Vcs fields to salsa.debian.org
  * Standards-Version: 4.1.4

 -- Andreas Tille <tille@debian.org>  Wed, 23 May 2018 17:59:29 +0200

=== debian/rules ===
#!/usr/bin/make -f
# debian/rules for bowtie
# Andreas Tille <tille@debian.org>
# GPL

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

pkg := bowtie

%:
	dh $@

override_dh_auto_build:
	$(MAKE) allall

override_dh_auto_install-arch:
	# remove strange byte-compyled Python code bowtie-buildc (no idea how and why it was created)
	find . -name bowtie-buildc -delete
	find . -name .cvsignore -delete

override_dh_installman-arch:
	help2man --name="ultrafast memory-efficient short read aligner" --no-info \
             $(CURDIR)/bowtie > $(CURDIR)/debian/$(pkg)/usr/share/man/man1/bowtie.1
	help2man --name="building a colorspace index for bowtie" --no-info \
             $(CURDIR)/bowtie-build > $(CURDIR)/debian/$(pkg)/usr/share/man/man1/bowtie-build.1
	help2man --name="extracts information from a bowtie index" --no-info \
             $(CURDIR)/bowtie-inspect > $(CURDIR)/debian/$(pkg)/usr/share/man/man1/bowtie-inspect.1

override_dh_compress:
	dh_compress -X.ebwt

# Fix bowtie-examples access mode for files in examples/
override_dh_fixperms-indep:
	dh_fixperms
	chmod 644 debian/bowtie-examples/usr/share/doc/bowtie/examples/indexes/*
#	Following line is not needed because gzipped genome/ (by dh_compress) is always 644.
#	chmod 644 debian/bowtie-examples/usr/share/doc/bowtie/examples/genomes/*

override_dh_auto_clean:
	rm -f .bowtie*
	dh_auto_clean

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	unset LD_PRELOAD && make simple-test
	ln -s debian/tests
	unset LD_PRELOAD && sh debian/tests/run-unit-test test_at_build_time
	rm -f tests examples[0-9].out
endif

## bowtie 1.3.0%2Bdfsg1

=== debian/watch ===
version=4

opts="repacksuffix=+dfsg,dversionmangle=s/\+dfsg//g,repack,compression=xz" \
  https://github.com/BenLangmead/bowtie/releases .*/archive/v(\d[-.\d]+)@ARCHIVE_EXT@

## bowtie 1.3.0+dfsg1

=== Makefile ===
--- 
+++ 
@@ -5,13 +5,8 @@
 prefix = /usr/local
 bindir = $(prefix)/bin
 
-SEQAN_DIR = ./SeqAn-1.1
-# treat SeqAn as a sysdir to suppress warnings
-SEQAN_INC = -isystem $(SEQAN_DIR)
-INC = $(if $(RELEASE_BUILD),-I$(CURDIR)/.include) $(SEQAN_INC) -I third_party
-CPP = g++
-CXX = $(CPP)
-CC = gcc
+ARCH = $(shell uname -m)
+INC = $(if $(RELEASE_BUILD),-I$(CURDIR)/.include) -I third_party
 LIBS = $(LDFLAGS) $(if $(RELEASE_BUILD),-L$(CURDIR)/.lib) -lz
 HEADERS = $(wildcard *.h)
 BOWTIE_MM = 1
@@ -21,8 +16,7 @@
 EXTRA_CXXFLAGS =
 CFLAGS += $(EXTRA_CFLAGS)
 CXXFLAGS += $(EXTRA_CXXFLAGS)
-WARNING_FLAGS = -Wall -Wno-unused-parameter -Wno-reorder \
-				-Wno-unused-local-typedefs
+WARNING_FLAGS = -Wall -Wno-unused-parameter -Wno-reorder
 
 RELEASE_DEPENDENCIES = $(if $(RELEASE_BUILD),static-libs)
 
@@ -50,8 +44,6 @@
 ifneq (,$(findstring Darwin,$(shell uname)))
     MACOS = 1
 	ifneq (,$(findstring 13,$(shell uname -r)))
-		CPP = clang++
-		CC = clang
 		override EXTRA_FLAGS += -stdlib=libstdc++
 	endif
 	ifeq (1, $(RELEASE_BUILD))
@@ -63,7 +55,7 @@
 ifneq (,$(findstring Linux,$(shell uname)))
     LINUX = 1
     override EXTRA_FLAGS += -Wl,--hash-style=both
-endif
+ endif
 
 MM_DEF = 
 ifeq (1,$(BOWTIE_MM))
@@ -76,11 +68,6 @@
 PTHREAD_PKG =
 PTHREAD_LIB =
 PTHREAD_DEF =
-
-#if we're not using TBB, then we can't use queuing locks
-ifeq (1,$(NO_TBB))
-	NO_QUEUELOCK=1
-endif
 
 ifeq (1,$(MINGW))
 	PTHREAD_LIB = 
@@ -93,15 +80,16 @@
 	override EXTRA_FLAGS += -DNO_SPINLOCK
 endif
 
-ifneq (1,$(NO_TBB))
-	LIBS += $(PTHREAD_LIB) -ltbb
-	LIBS += -ltbbmalloc$(if $(RELEASE_BUILD),,_proxy)
-	override EXTRA_FLAGS += -DWITH_TBB
-else
-	LIBS += $(PTHREAD_LIB)
+
+LIBS += $(PTHREAD_LIB)
+ifeq (1, $(WITH_TBBMALLOC))
+	LIBS += -ltbbmalloc
 endif
 
 POPCNT_CAPABILITY ?= 1
+ifeq (aarch64,$(shell uname -m))
+	POPCNT_CAPABILITY=0
+endif
 ifeq (1, $(POPCNT_CAPABILITY))
     override EXTRA_FLAGS += -DPOPCNT_CAPABILITY
     INC += -I third_party
@@ -124,33 +112,32 @@
 	override EXTRA_FLAGS += -DPER_THREAD_TIMING=1
 endif
 
-ifeq (1,$(WITH_AFFINITY))
-	override EXTRA_FLAGS += -DWITH_AFFINITY=1
+OTHER_CPPS = ccnt_lut.cpp ref_read.cpp alphabet.cpp shmem.cpp \
+             edit.cpp ebwt.cpp
+
+ifneq (1, $(NO_SPINLOCK))
+	OTHER_CPPS += bt2_locks.cpp
 endif
 
 ifeq (1,$(WITH_QUEUELOCK))
+	OTHER_CPPS += bt2_locks.cpp
 	override EXTRA_FLAGS += -DWITH_QUEUELOCK=1
 endif
 
 ifeq (1,$(WITH_FINE_TIMER))
 	override EXTRA_FLAGS += -DUSE_FINE_TIMER=1
 endif
-
-OTHER_CPPS = ccnt_lut.cpp ref_read.cpp alphabet.cpp shmem.cpp \
-             edit.cpp ebwt.cpp
 
 ifeq (1,$(WITH_COHORTLOCK))
 	override EXTRA_FLAGS += -DWITH_COHORTLOCK=1
 	OTHER_CPPS += cohort.cpp cpu_numa_info.cpp
 endif
 
-ifeq (1,$(NO_TBB))
-	OTHER_CPPS += tinythread.cpp
-endif
+OTHER_CPPS += tinythread.cpp
 
 SEARCH_CPPS = qual.cpp pat.cpp ebwt_search_util.cpp ref_aligner.cpp \
               log.cpp hit_set.cpp sam.cpp \
-              color.cpp color_dec.cpp hit.cpp
+              hit.cpp
 SEARCH_CPPS_MAIN = $(SEARCH_CPPS) bowtie_main.cpp
 
 BUILD_CPPS =
@@ -160,7 +147,7 @@
 VERSION = $(shell cat VERSION)
 
 BITS=32
-ifeq (x86_64,$(shell uname -m))
+ifeq (1,$(shell echo __LP64__ | $(CC) -P -E - | tr -d '\n'))
 	BITS=64
 endif
 # msys will always be 32 bit so look at the cpu arch instead.
@@ -170,18 +157,12 @@
 	endif
 endif
 
-ifeq (1,$(LINUX))
-    ifeq (x86_64, $(shell uname -p))
-        BITS=64
-    endif
-endif
-
 ifeq (32,$(BITS))
     $(error bowtie2 compilation requires a 64-bit platform )
 endif
 
-DEBUG_FLAGS = -O0 -g3 -m64
-RELEASE_FLAGS = -O3 -m64
+DEBUG_FLAGS = -O0 -g3
+RELEASE_FLAGS = -O3
 NOASSERT_FLAGS = -DNDEBUG
 FILE_FLAGS = -D_LARGEFILE_SOURCE -D_FILE_OFFSET_BITS=64 -D_GNU_SOURCE
 
@@ -205,7 +186,6 @@
                $(wildcard genomes/NC_008253.fna) \
                $(wildcard reads/e_coli_1000.*) \
                $(wildcard reads/e_coli_1000_*) \
-               SeqAn-1.1 \
                bowtie \
                bowtie-build \
                bowtie-inspect \
@@ -241,10 +221,19 @@
 
 allall: $(BIN_LIST) $(BIN_LIST_AUX)
 
+
+DATE_FMT = %Y-%m-%dT%H:%M:%S
+ifdef SOURCE_DATE_EPOCH
+    BUILD_DATE ?= $(shell date -u -d "@$(SOURCE_DATE_EPOCH)" "+$(DATE_FMT)" 2>/dev/null || date -u -r "$(SOURCE_DATE_EPOCH)" "+$(DATE_FMT)" 2>/dev/null || date -u "+$(DATE_FMT)")
+    BUILD_HOST := reproduciblebuild
+else
+    BUILD_DATE ?= $(shell date "+$(DATE_FMT)")
+    BUILD_HOST ?= `hostname`
+endif
 DEFS=-fno-strict-aliasing \
      -DBOWTIE_VERSION="\"`cat VERSION`\"" \
-     -DBUILD_HOST="\"`hostname`\"" \
-     -DBUILD_TIME="\"`date`\"" \
+     -DBUILD_HOST="\"$(BUILD_HOST)\"" \
+     -DBUILD_TIME="\"$(BUILD_DATE)\"" \
      -DCOMPILER_VERSION="\"`$(CXX) -v 2>&1 | tail -1`\"" \
      $(FILE_FLAGS) \
      $(PTHREAD_DEF) \
@@ -378,7 +367,7 @@
 		$(OTHER_CPPS) \
 		$(LIBS)
 
-bowtie-inspect-l-debug: bowtie_inspect.cpp $(HEADERS) $(OTHER_CPPS) 
+bowtie-inspect-l-debug: bowtie_inspect.cpp $(HEADERS) $(OTHER_CPPS)
 	$(CXX) $(DEBUG_FLAGS) \
 		$(DEBUG_DEFS) $(ALL_FLAGS) \
 		$(DEFS) -DBOWTIE_64BIT_INDEX $(WARNING_FLAGS) \
@@ -390,16 +379,16 @@
 bowtie-src.zip: $(SRC_PKG_LIST)
 	chmod a+x scripts/*.sh scripts/*.pl
 	mkdir .src.tmp
-	mkdir .src.tmp/bowtie-$(VERSION)
+	mkdir .src.tmp/bowtie-$(VERSION)-src
 	zip -r tmp.zip $(SRC_PKG_LIST)
-	mv tmp.zip .src.tmp/bowtie-$(VERSION)
-	cd .src.tmp/bowtie-$(VERSION) ; unzip tmp.zip ; rm -f tmp.zip
-	cd .src.tmp ; zip -r $@ bowtie-$(VERSION)
-	cp .src.tmp/$@ .
+	mv tmp.zip .src.tmp/bowtie-$(VERSION)-src
+	cd .src.tmp/bowtie-$(VERSION)-src ; unzip tmp.zip ; rm -f tmp.zip
+	cd .src.tmp ; zip -r bowtie-$(VERSION)-src.zip bowtie-$(VERSION)-src
+	cp .src.tmp/bowtie-$(VERSION)-src.zip .
 	rm -rf .src.tmp
 
-bowtie-bin.zip: $(RELEASE_DEPENDENCIES) $(BIN_PKG_LIST) $(BIN_LIST) $(BIN_LIST_AUX) 
-	$(eval PKG_DIR=bowtie-$(VERSION)-$(if $(MACOS),macos,$(if $(MINGW),mingw,linux))-x86_64)
+bowtie-bin.zip: $(RELEASE_DEPENDENCIES) $(BIN_PKG_LIST) $(BIN_LIST) $(BIN_LIST_AUX)
+	$(eval PKG_DIR=bowtie-$(VERSION)-$(if $(MACOS),macos,$(if $(MINGW),mingw,linux))-$(ARCH))
 	chmod a+x scripts/*.sh scripts/*.pl
 	rm -rf .bin.tmp
 	mkdir .bin.tmp
@@ -421,6 +410,7 @@
 doc/manual.html: MANUAL.markdown
 	echo "<h1>Table of Contents</h1>" > .tmp.head
 	pandoc -B .tmp.head \
+	       --ascii \
 	       --css style.css -o $@ \
 	       --from markdown --to HTML \
 	       --metadata title:"Bowtie Manual" \
@@ -444,10 +434,10 @@
 .PHONY: random-test
 random-test: all perl-deps
 	eval `perl -I $(CURDIR)/.perllib.tmp/lib/perl5 -Mlocal::lib=$(CURDIR)/.perllib.tmp` ; \
-	./scripts/test/random_bowtie_tests.sh
+	./scripts/test/random_bowtie_tests.sh $(*-command-variables-*-)
 
 .PHONY: perl-deps
 perl-deps:
 	if [ ! -e .perllib.tmp ]; then \
-		DL=$$([ `which wget` ] && echo wget -O- || echo curl -L) ; \
+		DL=$$([ `which wget` ] && echo "wget -O-" || echo "curl -L") ; \
 		mkdir .perllib.tmp ; \

=== debian/changelog ===
bowtie (1.3.0+dfsg1-1) unstable; urgency=medium

  [ Andreas Tille ]
  * Really fix arch all build

  [ Étienne Mollier ]
  * Excluded third_party/
    Closes: #972004
  * Reviewed debian/patches/popcnt_capability.patch

 -- Andreas Tille <tille@debian.org>  Tue, 13 Oct 2020 13:16:39 +0200

bowtie (1.3.0+dfsg-3) unstable; urgency=medium

  * Fix arch all build
  * Set POPCNT_CAPABILITY=0 for more architectures than just aarch64
    Closes: #972004

 -- Andreas Tille <tille@debian.org>  Mon, 12 Oct 2020 16:51:00 +0200

bowtie (1.3.0+dfsg-2) unstable; urgency=medium

  * Install usr/local/bin only if existing
    Closes: #972004

 -- Andreas Tille <tille@debian.org>  Mon, 12 Oct 2020 09:10:57 +0200

bowtie (1.3.0+dfsg-1) unstable; urgency=medium

  * New upstream version (upstream has adopted several patches)
  * Standards-Version: 4.5.0 (routine-update)
  * debhelper-compat 13 (routine-update)
  * Add salsa-ci file (routine-update)
  * Rules-Requires-Root: no (routine-update)
  * Set upstream metadata fields: Bug-Database, Bug-Submit, Repository,
    Repository-Browse.
  * Drop seqan-dev from Build-Depends
  * Point dh_install to binaries available in usr/local/bin

 -- Andreas Tille <tille@debian.org>  Tue, 15 Sep 2020 09:50:29 +0200

=== debian/control ===
--- 
+++ 
@@ -7,19 +7,19 @@
            Alexandre Mestiashvili <mestia@debian.org>
 Section: science
 Priority: optional
-Build-Depends: debhelper-compat (= 12),
+Build-Depends: debhelper-compat (= 13),
                help2man,
                libtbb-dev,
                python3,
-               seqan-dev,
                zlib1g-dev,
                libclone-perl,
                libtest-deep-perl,
                libsys-info-perl
-Standards-Version: 4.4.0
+Standards-Version: 4.5.0
 Vcs-Browser: https://salsa.debian.org/med-team/bowtie
 Vcs-Git: https://salsa.debian.org/med-team/bowtie.git
 Homepage: http://bowtie-bio.sourceforge.net/
+Rules-Requires-Root: no
 
 Package: bowtie
 Architecture: alpha any-amd64 arm64 mips64el ppc64 ppc64el s390x sparc64 riscv64

## bowtie 1.3.1

=== Makefile ===
--- 
+++ 
@@ -7,7 +7,7 @@
 
 ARCH = $(shell uname -m)
 INC = $(if $(RELEASE_BUILD),-I$(CURDIR)/.include) -I third_party
-LIBS = $(LDFLAGS) $(if $(RELEASE_BUILD),-L$(CURDIR)/.lib) -lz
+LIBS = $(LDFLAGS) $(if $(RELEASE_BUILD),-L$(CURDIR)/.lib) -lz -lpthread
 HEADERS = $(wildcard *.h)
 BOWTIE_MM = 1
 BOWTIE_SHARED_MEM = 1
@@ -65,25 +65,9 @@
 ifeq (1,$(BOWTIE_SHARED_MEM))
     SHMEM_DEF = -DBOWTIE_SHARED_MEM
 endif
-PTHREAD_PKG =
-PTHREAD_LIB =
-PTHREAD_DEF =
 
 ifeq (1,$(MINGW))
-	PTHREAD_LIB = 
 	override EXTRA_FLAGS += -static-libgcc -static-libstdc++
-else
-    PTHREAD_LIB = -lpthread
-endif
-
-ifeq (1,$(NO_SPINLOCK))
-	override EXTRA_FLAGS += -DNO_SPINLOCK
-endif
-
-
-LIBS += $(PTHREAD_LIB)
-ifeq (1, $(WITH_TBBMALLOC))
-	LIBS += -ltbbmalloc
 endif
 
 POPCNT_CAPABILITY ?= 1
@@ -92,7 +76,6 @@
 endif
 ifeq (1, $(POPCNT_CAPABILITY))
     override EXTRA_FLAGS += -DPOPCNT_CAPABILITY
-    INC += -I third_party
 endif
 
 PREFETCH_LOCALITY = 2
@@ -113,15 +96,16 @@
 endif
 
 OTHER_CPPS = ccnt_lut.cpp ref_read.cpp alphabet.cpp shmem.cpp \
-             edit.cpp ebwt.cpp
-
-ifneq (1, $(NO_SPINLOCK))
-	OTHER_CPPS += bt2_locks.cpp
-endif
+             edit.cpp ebwt.cpp bt2_locks.cpp
 
 ifeq (1,$(WITH_QUEUELOCK))
-	OTHER_CPPS += bt2_locks.cpp
-	override EXTRA_FLAGS += -DWITH_QUEUELOCK=1
+	NO_SPINLOCK = 1
+	override EXTRA_FLAGS += -DWITH_QUEUELOCK
+endif
+
+ifeq (1,$(NO_SPINLOCK))
+$(info $(NO_SPINLOCK))
+	override EXTRA_FLAGS += -DNO_SPINLOCK
 endif
 
 ifeq (1,$(WITH_FINE_TIMER))
@@ -242,8 +226,8 @@
      $(SHMEM_DEF)
 
 ALL_FLAGS = $(EXTRA_FLAGS) $(CFLAGS) $(CXXFLAGS)
-DEBUG_DEFS = -DCOMPILER_OPTIONS="\"$(DEBUG_FLAGS) $(ALL_FLAGS)\""
-RELEASE_DEFS = -DCOMPILER_OPTIONS="\"$(RELEASE_FLAGS) $(ALL_FLAGS)\""
+DEBUG_DEFS = -DCOMPILER_OPTIONS="\"$(DEBUG_FLAGS) $(EXTRA_FLAGS) $(CFLAGS) $(CXXFLAGS)\""
+RELEASE_DEFS = -DCOMPILER_OPTIONS="\"$(RELEASE_FLAGS) $(EXTRA_FLAGS) $(CFLAGS) $(CXXFLAGS)\""
 
 #
 # bowtie-build targets
@@ -441,3 +425,5 @@
 	if [ ! -e .perllib.tmp ]; then \
 		DL=$$([ `which wget` ] && echo "wget -O-" || echo "curl -L") ; \
 		mkdir .perllib.tmp ; \
+		$$DL http://cpanmin.us | perl - -l $(CURDIR)/.perllib.tmp App::cpanminus local::lib ; \
+		eval `perl -I $(CURDIR)/.perllib.tmp/lib/perl5 -Mlocal::lib=$(CURDIR)/.perllib.tmp` ; \

=== debian/changelog ===
bowtie (1.3.1-3) unstable; urgency=medium

  * Fix clean target
    Closes: #1043697

 -- Andreas Tille <tille@debian.org>  Thu, 25 Jan 2024 12:27:31 +0100

bowtie (1.3.1-2) unstable; urgency=medium

  * Exclude i386 build in salsa-ci
  * Disable reprotest
  * Add loong64 to list of architectures
    Closes: #1058573
  * Standards-Version: 4.6.2 (routine-update)
  * Use secure URI in Homepage field.
  * Lintian-overrides (see lintian bug #1017966)

 -- Andreas Tille <tille@debian.org>  Fri, 15 Dec 2023 20:54:44 +0100

bowtie (1.3.1-1) unstable; urgency=medium

  * New upstream version
  * Fix watchfile to detect new versions on github (routine-update)
  * Standards-Version: 4.6.0 (routine-update)
  * Update renamed lintian tag names in lintian overrides.
  * Apply multi-arch hints.
    + bowtie-examples: Add Multi-Arch: foreign.
  * No need to exclude files from upstream tarball any more

 -- Andreas Tille <tille@debian.org>  Tue, 14 Sep 2021 07:01:35 +0200

=== debian/control ===
--- 
+++ 
@@ -15,14 +15,14 @@
                libclone-perl,
                libtest-deep-perl,
                libsys-info-perl
-Standards-Version: 4.5.0
+Standards-Version: 4.6.2
 Vcs-Browser: https://salsa.debian.org/med-team/bowtie
 Vcs-Git: https://salsa.debian.org/med-team/bowtie.git
-Homepage: http://bowtie-bio.sourceforge.net/
+Homepage: https://bowtie-bio.sourceforge.net/
 Rules-Requires-Root: no
 
 Package: bowtie
-Architecture: alpha any-amd64 arm64 mips64el ppc64 ppc64el s390x sparc64 riscv64
+Architecture: alpha any-amd64 arm64 loong64 mips64el ppc64 ppc64el s390x sparc64 riscv64
 Multi-Arch: foreign
 Depends: ${shlibs:Depends},
          ${misc:Depends},
@@ -45,6 +45,7 @@
 Depends: ${misc:Depends}
 Recommends: bowtie
 Enhances: bowtie
+Multi-Arch: foreign
 Description: Examples for bowtie, the ultrafast memory-efficient short read aligner
  This package addresses the problem to interpret the results from the
  latest (2010) DNA sequencing technologies. Those will yield fairly

=== debian/rules ===
--- 
+++ 
@@ -21,6 +21,12 @@
 	find . -name bowtie-buildc -delete
 	find . -name .cvsignore -delete
 
+override_dh_install:
+	dh_install
+	if [ -d debian/tmp/usr/local/bin ] ; then \
+	    dh_install -a usr/local/bin	usr ; \
+	fi
+
 override_dh_installman-arch:
 	help2man --name="ultrafast memory-efficient short read aligner" --no-info \
              $(CURDIR)/bowtie > $(CURDIR)/debian/$(pkg)/usr/share/man/man1/bowtie.1
@@ -39,8 +45,13 @@
 #	Following line is not needed because gzipped genome/ (by dh_compress) is always 644.
 #	chmod 644 debian/bowtie-examples/usr/share/doc/bowtie/examples/genomes/*
 
+override_dh_missing-indep:
+	dh_missing -i --list-missing
+
 override_dh_auto_clean:
 	rm -f .bowtie*
+	rm -f .simple*
+	rm -rf __pycache__
 	dh_auto_clean
 
 override_dh_auto_test:

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/BenLangmead/bowtie/tags (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@
